import { IGQLType } from "prisma-datamodel";
export declare const users: {
    _id: string;
    firstName: string;
    orders: {
        count: number;
        item: string;
    }[];
}[];
export declare const items: {
    _id: string;
    cost: number;
}[];
export declare const schemaString = "type Item {\n  # Type String is currently not supported for id fields.\n  _id: String! @id\n  cost: Int\n}\n\ntype User {\n  # Type String is currently not supported for id fields.\n  _id: String! @id\n  firstName: String\n  orders: [UserOrders!]!\n}\n\ntype UserOrders @embedded {\n  count: Int\n  item: Item @relation(link: INLINE)\n}";
export declare function assertUserItemModel(allTypes: IGQLType[]): void;
