export declare const users: ({
    _id: string;
    firstName: string;
    lastName: string;
    paymentInfo: {
        type: string;
        IBAN: string;
        BIC: string;
    }[];
    shippingAddress: {
        street: string;
        country: string;
        number: string;
    };
} | {
    _id: string;
    firstName: string;
    lastName: string;
    paymentInfo: ({
        type: string;
        accountId: string;
        expires?: undefined;
        number?: undefined;
    } | {
        type: string;
        expires: string;
        number: string;
        accountId?: undefined;
    })[];
    shippingAddress: {
        street: string;
        country: string;
        number: string;
    };
})[];
export declare const items: {
    _id: string;
    price: number;
    rating: number;
    reviews: ({
        rating: number;
        text?: undefined;
    } | {
        rating: number;
        text: string;
    })[];
    keywords: string[];
}[];
export declare const orders: {
    _id: number;
    customer: string;
    orderDate: string;
    amount: number;
    items: string[];
}[];
export declare const collections: {
    User: ({
        _id: string;
        firstName: string;
        lastName: string;
        paymentInfo: {
            type: string;
            IBAN: string;
            BIC: string;
        }[];
        shippingAddress: {
            street: string;
            country: string;
            number: string;
        };
    } | {
        _id: string;
        firstName: string;
        lastName: string;
        paymentInfo: ({
            type: string;
            accountId: string;
            expires?: undefined;
            number?: undefined;
        } | {
            type: string;
            expires: string;
            number: string;
            accountId?: undefined;
        })[];
        shippingAddress: {
            street: string;
            country: string;
            number: string;
        };
    })[];
    Order: {
        _id: number;
        customer: string;
        orderDate: string;
        amount: number;
        items: string[];
    }[];
    Item: {
        _id: string;
        price: number;
        rating: number;
        reviews: ({
            rating: number;
            text?: undefined;
        } | {
            rating: number;
            text: string;
        })[];
        keywords: string[];
    }[];
};
export declare const schemaString = "type Item {\n  # Type String is currently not supported for id fields.\n  _id: String! @id\n  keywords: [String!]!\n  price: Float\n  rating: Float\n  reviews: [ItemReviews!]!\n}\n\ntype ItemReviews @embedded {\n  rating: Float\n  text: String\n}\n\ntype Order {\n  # Type Int is currently not supported for id fields.\n  _id: Int! @id\n  amount: Float\n  customer: User @relation(link: INLINE)\n  items: [Item!]! @relation(link: INLINE)\n  orderDate: String\n}\n\ntype User {\n  # Type String is currently not supported for id fields.\n  _id: String! @id\n  firstName: String\n  lastName: String\n  paymentInfo: [UserPaymentInfo!]!\n  shippingAddress: UserShippingAddress\n}\n\ntype UserPaymentInfo @embedded {\n  accountId: String\n  BIC: String\n  expires: String\n  IBAN: String\n  number: String\n  type: String\n}\n\ntype UserShippingAddress @embedded {\n  country: String\n  number: String\n  street: String\n}";
