"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var prisma_datamodel_1 = require("prisma-datamodel");
var postgresConnector_1 = require("./databases/relational/postgres/postgresConnector");
var mongoConnector_1 = require("./databases/document/mongo/mongoConnector");
var Connectors = /** @class */ (function () {
    function Connectors() {
    }
    // TODO: find a proper type for databse config
    Connectors.create = function (databaseType, databaseConfig) {
        switch (databaseType) {
            case prisma_datamodel_1.DatabaseType.mongo: throw new mongoConnector_1.MongoConnector(databaseConfig);
            case prisma_datamodel_1.DatabaseType.postgres: return new postgresConnector_1.PostgresConnector(databaseConfig);
            default: throw new Error('Not implemented.');
        }
    };
    return Connectors;
}());
exports.default = Connectors;
//# sourceMappingURL=connectors.js.map