import { MongoClient } from "mongodb";
import { Data } from "../databases/document/data";
export interface IDocumentTestEnvironment {
    schemaName: string;
    connect(): Promise<void>;
    disconnect(): Promise<void>;
    clear(): Promise<void>;
    createCollection(name: string, document: Data[]): Promise<void>;
    createCollections(collections: {
        [name: string]: Data[];
    }): Promise<void>;
}
export declare class MongoTestEnvironment implements IDocumentTestEnvironment {
    private uri;
    private schema;
    private client;
    readonly schemaName: string;
    constructor(uri?: string, schema?: string);
    connect(): Promise<void>;
    getClient(): MongoClient;
    getSchema(): import("mongodb").Db;
    clear(): Promise<void>;
    createCollection(name: string, documents: Data[]): Promise<void>;
    createCollections(collections: {
        [name: string]: Data[];
    }): Promise<void>;
    disconnect(): Promise<void>;
}
